> For the complete documentation index, see [llms.txt](https://docs.thehemera.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.thehemera.com/hemera-indexer/use-cases/uniswap-v3/run-and-query.md).

# Run & Query

## 1. Configuration

In the `indexer/modules/custom/uniswap_v3/config.ini` file, configure the protocol information for your specific blockchain. Use the `chainId` as the key.

## 2. Verify ABI

Ensure that the ABI matches the Uniswap V3 protocol you're working with. If it doesn't, update the ABI in the `indexer/modules/custom/uniswap_v3/constants.py` file.

## 3. Indexing Data

To start indexing the data, run the following command:

```bash
python hemera.py stream -pg postgresql://{db_user}:{db_password}@{db_url}:5432/{database} -p {chain_rpc} -s {start_block_number} -e {end_block_number} -o postgres -B 1000 -w 5 -b 100 -E {entity_type}
```

(you can add your {entity\_type} in `enumeration/entity_type.py`)

## 4. Verify Data

### Get Current Holdings for a Wallet Address

First, retrieve all tokenIds held by the wallet\_address, and then fetch the prices for the pools associated with these tokenIds.

API Path: `/v1/aci/<wallet_address>/uniswapv3/current_holding`

### Get First Liquidity Addition Time for a Wallet Address

API Path: `/v1/aci/<wallet_address>/uniswapv3/first_liquidity_time`

### Get the Number of Pools with Liquidity Added or Removed by a Wallet Address

API Path: `/v1/aci/<wallet_address>/uniswapv3/provide_liquidity_pool_count`


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.thehemera.com/hemera-indexer/use-cases/uniswap-v3/run-and-query.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
